
---@param table table
---@param element any
function table.contains(table, element)
	-- check each value in the table
    for _, value in pairs(table) do
		-- check if that value is equal to the element
      	if value == element then
			-- if so, we are good to go, and the table contains the element, return true!
        	return true
      	end
    end

	-- if we finish the loop, we didn't find the entry in the table, so return false
	return false
end

---@param table table
---@param element any
function table.pos_of_element(table, element)
	-- check each value in the table
    for key, value in pairs(table) do
		-- check if that value is equal to the element
      	if value == element then
			-- if so, we found the element, return index
        	return key
      	end
    end

	-- if we finish the loop, we didn't find the entry in the table, so return false
	return false
end

function linear_interpolation(input, minRange, maxRange, minInput, maxInput)
    local m = (maxRange - minRange) / (maxInput - minInput)
    local b = minRange - m * minInput

    return m * input + b
end

-- for those wondering, a "game" is all the gamemodes into one main event, a "gamemode" is the minigame. Ik terrible naming scheme
function start_game()
	-- you might be wondering why I even have this in a function. I've learned a lot from making Tag, one of those
	-- things being focus on expandibility when you can, now is that time. If I ever need to change this, I can!

	-- cuts a lot of the unused code
	gGlobalSyncTable.gamemode = get_random_gamemode_key()
	gGlobalSyncTable.roundState = ROUND_STATE_GAMEMODE_WAITING
	--gGlobalSyncTable.roundState = ROUND_STATE_GAMEMODE_SELECTOR
end

function safe_start_game()

	if not network_is_server() and not network_is_moderator() then return end

	if gGlobalSyncTable.roundState ~= ROUND_STATE_WAITING then
		log_to_console("Fall Guys: Failed to start game, since a round is already in play!", CONSOLE_MESSAGE_WARNING)
		return false
	end

	start_game()
	return true
end

function get_all_gamemode_keys()
	local gamemodeKeys = {}
	for key in ipairs(gamemodes) do
		table.insert(gamemodeKeys, key)
	end

	return gamemodeKeys
end

function get_random_gamemode_key()
	-- with the way the gamemode system works, I got to use one of the worst random selectors known to date
	-- do I care? No, if it aint broke, don't fix it, that's why this mod is gonna be terrible :D
	-- actually on second thought with organization this doesn't look as bad as it actually is
	-- trust be if you remove the "get_all_gamemode_keys" function, it's ugly.
	return get_all_gamemode_keys()[math.random(1, #get_all_gamemode_keys())]
end

function start_gamemode(key)
	-- set's gamemode to specified gamemode to start
    gGlobalSyncTable.gamemode = key
	-- sets round state to gamemode waiting
    gGlobalSyncTable.roundState = ROUND_STATE_GAMEMODE_WAITING
end

function get_alive_players()
	local players = {}
	for i = 0, MAX_PLAYERS - 1 do
		local np = gNetworkPlayers[i]
		local s = gPlayerSyncTable[i]

		if np.connected and s.role == ROLE_ACTIVE then
			table.insert(players, i)
		end
	end
	return players
end

function get_alive_player_count()
	return #get_alive_players()
end

function find_active_player(includeLocalIndex)
	local minIndex = includeLocalIndex and 0 or 1
	for i = minIndex, MAX_PLAYERS - 1 do
		if gNetworkPlayers[i].connected and gPlayerSyncTable[i].role == ROLE_ACTIVE then
			return i
		end
	end

	return nil
end

function eliminate_me()
	if gPlayerSyncTable[0].role == ROLE_INACTIVE or gPlayerSyncTable[0].role == ROLE_SPECTATOR then return end
	gPlayerSyncTable[0].role = ROLE_INACTIVE
	show_elimination_hud()
end

function get_player_name(i)
	return network_get_player_text_color_string(i) .. gNetworkPlayers[i].name
end

-- credit to jsmorely on some forum site
function hex_to_rgb(hex)
	-- remove the # and the \\ from the hex so that we can convert it properly
	hex = hex:gsub('#','')
	hex = hex:gsub('\\','')

	-- honestly I copied this from the rainmeter (windows customization) forum... credit to jsmorely!
	if string.len(hex) == 3 then
		return tonumber('0x'..hex:sub(1,1)) * 17, tonumber('0x'..hex:sub(2,2)) * 17, tonumber('0x'..hex:sub(3,3)) * 17
	elseif string.len(hex) == 6 then
		return tonumber('0x'..hex:sub(1,2)), tonumber('0x'..hex:sub(3,4)), tonumber('0x'..hex:sub(5,6))
	else
		return 0, 0, 0
	end
end

function rgb_to_hex(r, g, b)
	return string.format("#%02X%02X%02X", r, g, b)
end

-- credit to agent x
function strip_hex(name)
	-- create variables
	local s = ''
	local inSlash = false
	-- the way this works is if your in a slash, you dont add the characters in the slash,
	-- otherwise, you do, this allows you to skip the hex's

	-- loop thru each character in the string
	for i = 1, #name do
		local c = name:sub(i,i)
		if c == '\\' then
			-- we are now in (or out) of the slash, set variable accordingly
			inSlash = not inSlash
		elseif not inSlash then
			s = s .. c
		end
	end
	return s
end

function toggle_spectating()
	local s = gPlayerSyncTable[0]
    if s.role == ROLE_SPECTATOR then
        s.role = ROLE_INACTIVE
		return
    end

    s.role = ROLE_SPECTATOR
end