
-- if you're curious, yea this was taken directly from tag. Don't really care, if it ain't broke don't fix it.

TEXTURE_QUARTER_CIRCLE = get_texture_info("quarter_circle")

---@param text string
---@param x integer
---@param y integer
---@param scale integer
function djui_hud_print_colored_text(text, x, y, scale, opacity)
    -- just incase silly me does something stupid
    text = tostring(text)
	local inSlash = false
    local hex = ""
    if opacity == nil then opacity = 255 end

	-- loop thru each character in the string and render that char
	for i = 1, #text do
        -- get character
		local c = text:sub(i,i)
        -- if character is a backslash, then switch inslash
		if c == "\\" then
			-- we are now in (or out) of the slash, set variable accordingly
			inSlash = not inSlash
            -- reset hex if needed
            if inSlash then
                hex = ""
            end
        elseif inSlash then
            -- set hex var
            hex = hex .. c
		elseif not inSlash then
            if hex:len() == 7 then
                -- get rgb
                local r, g, b = hex_to_rgb(hex)
                -- set color to rgb
                djui_hud_set_color(r, g, b, opacity)
            end
            -- print character
            djui_hud_print_text(c, x, y, scale)
            -- increase position
            x = x + (djui_hud_measure_text(c) * scale)
		end
	end
end

---@param x number|integer
---@param y number|integer
---@param width number|integer
---@param height number|integer
---@param oR number|integer
---@param oG number|integer
---@param oB number|integer
---@param thickness number|integer
---@param opacity number|integer|nil
function djui_hud_render_rect_outlined(x, y, width, height, oR, oG, oB, thickness, opacity)
    if opacity == nil then opacity = 255 end
    -- render main rect
    djui_hud_render_rect(x, y, width, height)
    -- set outline color to, well, outline color
    djui_hud_set_color(oR, oG, oB, opacity)
    -- render rect outside of each side
    djui_hud_render_rect(x - thickness, y - thickness, thickness, height + thickness * 2)
    djui_hud_render_rect(x + (width - thickness) + thickness, y, thickness, height + thickness)
    djui_hud_render_rect(x, y - thickness, width + thickness, thickness)
    djui_hud_render_rect(x, y + (height - thickness) + thickness, width, thickness)
end

---@param x number|integer
---@param y number|integer
---@param width number|integer
---@param height number|integer
---@param cornerRaidus number|integer
function djui_hud_render_rect_rounded(x, y, width, height, cornerRaidus)
    if cornerRaidus > width then cornerRaidus = width end
    if cornerRaidus > height then cornerRaidus = height end
    -- it's called black magic
    djui_hud_render_rect(x + (cornerRaidus / 2), y, width - cornerRaidus, height)
    djui_hud_render_rect(x, y + (cornerRaidus / 2), cornerRaidus / 2, height - cornerRaidus)
    djui_hud_render_rect(x + width - cornerRaidus / 2, y + (cornerRaidus / 2), cornerRaidus / 2, height - cornerRaidus)
    -- render corners
    local circleDimensions = (1 / 64) * cornerRaidus / 2
    -- top left corner
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x, y, circleDimensions, circleDimensions)
    -- bottom left corner
    djui_hud_set_rotation(0x4000, 0, 0)
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x, y + height, circleDimensions, circleDimensions)
    -- top right corner
    djui_hud_set_rotation(-0x4000, 0, 0)
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x + width, y, circleDimensions, circleDimensions)
    -- bottom right corner
    djui_hud_set_rotation(0x8000, 0, 0)
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x + width, y + height, circleDimensions, circleDimensions)
    djui_hud_set_rotation(0, 0, 0)
end

---@param x number|integer
---@param y number|integer
---@param width number|integer
---@param height number|integer
---@param cornerRaidus number|integer
function djui_hud_render_rect_rounded_ignore_bottom(x, y, width, height, cornerRaidus)
    -- it's called black magic
    djui_hud_render_rect(x + (cornerRaidus / 2), y, width - cornerRaidus, height)
    djui_hud_render_rect(x, y + (cornerRaidus / 2), cornerRaidus / 2, height - cornerRaidus / 2)
    djui_hud_render_rect(x + width - cornerRaidus / 2, y + (cornerRaidus / 2), cornerRaidus / 2, height - cornerRaidus / 2)
    -- render corners
    local circleDimensions = (1 / 64) * cornerRaidus / 2
    -- top left corner
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x, y, circleDimensions, circleDimensions)
    -- top right corner
    djui_hud_set_rotation(-0x4000, 0, 0)
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x + width, y, circleDimensions, circleDimensions)
    djui_hud_set_rotation(0, 0, 0)
end

-- currently only viable with coopdx
---@param x number|integer
---@param y number|integer
---@param width number|integer
---@param height number|integer
---@param oR number|integer
---@param oG number|integer
---@param oB number|integer
---@param thickness number|integer
---@param opacity number|integer|nil
function djui_hud_render_rect_rounded_outlined(x, y, width, height, oR, oG, oB, thickness, opacity)
    if opacity == nil then opacity = 255 end
    local cornerRaidus = thickness
    -- render rounded rect using those saved colors
    djui_hud_render_rect(x, y, width, height)
    -- render rect outside of each side
    djui_hud_set_color(oR, oG, oB, opacity)
    djui_hud_render_rect(x - thickness, y, thickness, height)
    djui_hud_render_rect(x + (width - thickness) + thickness, y, thickness, height)
    djui_hud_render_rect(x, y - thickness, width, thickness)
    djui_hud_render_rect(x, y + (height - thickness) + thickness, width, thickness)
    -- render outline corners
    local circleDimensions = (1 / 64) * cornerRaidus
    -- top left corner
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x - thickness, y - thickness, circleDimensions, circleDimensions)
    -- bottom left corner
    djui_hud_set_rotation(0x4000, 0, 0)
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x - thickness, y + height + thickness, circleDimensions, circleDimensions)
    -- top right corner
    djui_hud_set_rotation(-0x4000, 0, 0)
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x + width + thickness, y - thickness, circleDimensions, circleDimensions)
    -- bottom right corner
    djui_hud_set_rotation(0x8000, 0, 0)
    djui_hud_render_texture(TEXTURE_QUARTER_CIRCLE, x + width + thickness, y + height + thickness, circleDimensions, circleDimensions)
    djui_hud_set_rotation(0, 0, 0)
end

-- this entire snippet for the player head was made by EmilyEmmi (with adjustments for tag, erm actually fall guys, made by me :), thanks!
local PART_ORDER = {
    SKIN,
    HAIR,
    CAP,
}

HEAD_HUD = get_texture_info("hud_head_recolor")
WING_HUD = get_texture_info("hud_wing")

-- the actual head render function.
--- @param index integer
--- @param x integer
--- @param y integer
--- @param scaleX number
--- @param scaleY number
--- @param opacity number|nil
function render_player_head(index, x, y, scaleX, scaleY, opacity)
    if opacity == nil then opacity = 255 end
    local m = gMarioStates[index]
    local np = gNetworkPlayers[index]

    local alpha = 255 / (255 / opacity)
    if m.marioBodyState.modelState & MODEL_STATE_NOISE_ALPHA ~= 0 then
        alpha = 100 / (255 / opacity) -- vanish effect
    end
    local isMetal = false

    local tileY = m.character.type
    for i = 1, #PART_ORDER do
        local color = {r = 255, g = 255, b = 255}
		if m.marioBodyState.modelState & MODEL_STATE_METAL ~= 0 then -- metal
			color = network_player_get_override_palette_color(np, METAL)
            if color == nil then break end
			djui_hud_set_color(color.r, color.g, color.b, alpha)
			djui_hud_render_texture_tile(HEAD_HUD, x, y, scaleX, scaleY, 5 * 16, tileY * 16, 16, 16)
			isMetal = true

			break
		end

		local part = PART_ORDER[i]
		if tileY == 2 and part == HAIR then -- toad doesn't use hair, bald
			part = GLOVES
		end

		color = network_player_get_override_palette_color(np, part)

        djui_hud_set_color(color.r, color.g, color.b, alpha)
        djui_hud_render_texture_tile(HEAD_HUD, x, y, scaleX, scaleY, (i-1)*16, tileY*16, 16, 16)
    end

    if not isMetal then
        djui_hud_set_color(255, 255, 255, alpha)
        djui_hud_render_texture_tile(HEAD_HUD, x, y, scaleX, scaleY, (#PART_ORDER) * 16, tileY * 16, 16, 16)

        djui_hud_render_texture_tile(HEAD_HUD, x, y, scaleX, scaleY, (#PART_ORDER + 1) * 16, tileY * 16, 16, 16) -- hat emblem
        if m.marioBodyState.capState == MARIO_HAS_WING_CAP_ON then
            djui_hud_render_texture(WING_HUD, x, y, scaleX, scaleY) -- wing
        end
    elseif m.marioBodyState.capState == MARIO_HAS_WING_CAP_ON then
        djui_hud_set_color(109, 170, 173, alpha) -- blueish green
        djui_hud_render_texture(WING_HUD, x, y, scaleX, scaleY) -- wing
    end
end

---@param texInfo TextureInfo
---@param x number
---@param y number
---@param scaleW number
---@param scaleH number
function djui_hud_render_texture_scaled(texInfo, x, y, scaleW, scaleH)
    djui_hud_render_texture(texInfo, x, y, scaleW / texInfo.width, scaleH / texInfo.height)
end