
TEXTURE_YELLOW_SELECTOR_BACKGROUND = get_texture_info("yellow_selector_background")
TEXTURE_BLUE_SELECTOR_BACKGROUND = get_texture_info("blue_selector_background")

local hudFade = 0

local function hud_selector()
    local screenWidth = djui_hud_get_screen_width()
    local screenHeight = djui_hud_get_screen_height()

    local x = 0
    local y = 0

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_render_texture_scaled(TEXTURE_YELLOW_SELECTOR_BACKGROUND, x, y, screenWidth, screenHeight)

    local rectWidth = screenWidth
    local rectHeight = 75

    y = 30

    djui_hud_set_color(34, 33, 38, hudFade)
    djui_hud_render_rect(x, y, rectWidth, rectHeight)

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_print_text("Next up is:", x + 40, y + 5, 2)

    rectHeight = 50

    y = screenHeight - rectHeight - 30

    djui_hud_set_color(34, 33, 38, hudFade)
    djui_hud_render_rect(x, y, rectWidth, rectHeight)

    rectWidth = 530
    rectHeight = 530

    x = screenWidth / 2 - rectWidth / 2
    y = screenHeight / 2 - rectHeight / 2

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_render_rect_rounded(x, y, rectWidth, rectHeight, 25)
end

local function hud_gamemode_info()
    local screenWidth = djui_hud_get_screen_width()
    local screenHeight = djui_hud_get_screen_height()

    local x = 0
    local y = 0

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_render_texture_scaled(TEXTURE_BLUE_SELECTOR_BACKGROUND, x, y, screenWidth, screenHeight)

    local rectWidth = 498
    local rectHeight = 28

    x = -20
    y = 33 + rectHeight

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_render_rect_rounded(x, y, rectWidth + 20, rectHeight, 20)

    rectWidth = 520
    rectHeight = 118

    y = 25

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_render_rect_rounded(x, y, rectWidth + 20, rectHeight, 40)

    y = y + rectHeight - 16

    rectWidth = 498
    rectHeight = 38

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_render_rect_rounded(x, y, rectWidth + 20, rectHeight, 20)

    rectWidth = 490
    rectHeight = 30

    djui_hud_set_color(32, 35, 40, hudFade)
    djui_hud_render_rect_rounded(x, y, rectWidth + 20, rectHeight, 20)

    rectWidth = 504
    rectHeight = 102

    x = x + 8
    y = 25 + 8

    djui_hud_set_color(252, 41, 148, hudFade)
    djui_hud_render_rect_rounded(x, y, rectWidth + 20, rectHeight, 20)

    x = 19
    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_print_text(get_current_gamemode().name, x, y, 3)

    rectWidth = screenWidth
    rectHeight = 50

    x = 0
    y = screenHeight - rectHeight - 30

    djui_hud_set_color(34, 33, 38, hudFade)
    djui_hud_render_rect(x, y, rectWidth, rectHeight)

    rectWidth = 530
    rectHeight = 530

    x = screenWidth / 2 - rectWidth / 2
    y = screenHeight / 2 - rectHeight / 2

    djui_hud_set_color(255, 255, 255, hudFade)
    djui_hud_render_rect_rounded(x, y, rectWidth, rectHeight, 25)
end

local function hud_render()

    if gGlobalSyncTable.roundState ~= ROUND_STATE_GAMEMODE_SELECTOR then
        hudFade = hudFade - 20
        if hudFade < 0 then hudFade = 0 end
    else
        hudFade = hudFade + 20
        if hudFade > 255 then hudFade = 255 end
    end

    djui_hud_set_resolution(RESOLUTION_DJUI)
    djui_hud_set_font(djui_hud_get_font())

    if get_current_gamemode() then
        hud_gamemode_info()
    else
        hud_selector()
    end
end

hook_event(HOOK_ON_HUD_RENDER, hud_render)