
--[[E_MODEL_HAMMER_BASE = smlua_model_util_get_id("horizontal_hammer_base_geo")
E_MODEL_HAMMER = smlua_model_util_get_id("horizontal_hammer_geo")
COL_HAMMER_BASE = smlua_collision_util_get("horizontal_hammer_base_collision")
COL_HAMMER = smlua_collision_util_get("horizontal_hammer_collision")

---@param o Object
local function hammer_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_HAMMER_BASE
    o.oPosY = o.oPosY + 200 * 0.6
    cur_obj_scale(0.6)
    obj_set_model_extended(o, E_MODEL_HAMMER_BASE)
    spawn_non_sync_object(id_bhvHammerChild, E_MODEL_HAMMER, o.oPosX, o.oPosY, o.oPosZ, nil)
end

---@param o Object
local function hammer_child_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_HAMMER
    cur_obj_scale(0.6)
end

---@param o Object
local function hammer_child_loop(o)
    o.oFaceAngleYaw = o.oFaceAngleYaw + 2000
    ---@type MarioState
    local m = gMarioStates[0]
    if (m.wall and m.wall.object == o)
    or m.ceil and m.ceil.object == o then
        if m.action ~= ACT_THROWN_BACKWARD then
            set_mario_action(m, ACT_THROWN_BACKWARD, 0)
        end
        m.squishTimer = 0
        m.faceAngle.y = o.oFaceAngleYaw - 0x4000
        if m.ceil and m.ceil.object == o then
            m.pos.y = m.pos.y + 200
        end
        m.marioObj.oInteractStatus = m.marioObj.oInteractStatus | INT_STATUS_MARIO_UNK2
        m.forwardVel = -60
        m.vel.y = 40
    end
    load_object_collision_model()
end

id_bhvHammer = hook_behavior(nil, OBJ_LIST_SURFACE, false, hammer_init, function () load_object_collision_model() end, "bhvHammer")
id_bhvHammerChild = hook_behavior(nil, OBJ_LIST_SURFACE, false, hammer_child_init, hammer_child_loop, "bhvHammerChild")

---@param o Object
local function yeetus_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_HAMMER_BASE
    cur_obj_scale(0.6)
    obj_set_model_extended(o, E_MODEL_HAMMER_BASE)
    o.oFaceAngleRoll = o.oFaceAngleRoll + 0x4000
    spawn_non_sync_object(id_bhvYeetusChild, E_MODEL_HAMMER, o.oPosX, o.oPosY, o.oPosZ, nil)
end

---@param o Object
local function yeetus_child_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.collisionData = COL_HAMMER
    o.oFaceAngleRoll = o.oFaceAngleRoll + 0x4000
    cur_obj_scale(0.6)
end

---@param o Object
local function yeetus_child_loop(o)
    o.oFaceAnglePitch = 0x4000
    ---@type MarioState
    local m = gMarioStates[0]
    if (m.wall and m.wall.object == o)
    or (m.ceil and m.ceil.object == o)
    or (m.floor and m.floor.object == o and m.floorHeight == m.pos.y) then
        if m.action ~= ACT_THROWN_BACKWARD then
            set_mario_action(m, ACT_THROWN_BACKWARD, 0)
        end
        m.squishTimer = 0
        m.faceAngle.y = o.oFaceAngleYaw
        if (m.ceil and m.ceil.object == o) or (m.floor and m.floor.object == o and m.floorHeight == m.pos.y) then
            m.pos.y = m.pos.y + 200
        end
        m.marioObj.oInteractStatus = m.marioObj.oInteractStatus | INT_STATUS_MARIO_UNK2
        m.forwardVel = -60
        m.vel.y = 40
    end
    load_object_collision_model()
end

id_bhvYeetus = hook_behavior(nil, OBJ_LIST_SURFACE, false, yeetus_init, function () load_object_collision_model() end, "bhvYeetus")
id_bhvYeetusChild = hook_behavior(nil, OBJ_LIST_SURFACE, false, yeetus_child_init, yeetus_child_loop, "bhvYeetusChild")

local function level_init()
    spawn_non_sync_object(id_bhvYeetus, E_MODEL_HAMMER_BASE, gMarioStates[0].pos.x, gMarioStates[0].pos.y + 400, gMarioStates[0].pos.z, nil)
end

hook_event(HOOK_ON_LEVEL_INIT, level_init)--]]